#include <iostream.h>
#include <string.h>
#include <stdio.h>
struct zveno
{
   char Element; //.
   float  Kol;   // p,
                 // p.
   zveno* Sled;
   zveno* Left;
   zveno* Right;
   zveno* Father;
};

class Tree
{
  private:
    zveno *UkStr; //  .
    int Poisk1 (zveno**,float, zveno**);
  public:
    Tree () { UkStr = new (zveno); UkStr->Sled = NULL; };
    int Poisk (char, zveno **);
    int Kolich (char *, char);
    void Dobavlenie (char, float, zveno**);
    void Redaktor (int);
    void Ukazateli (zveno **, zveno **);
    void Vyvod ();
    void WstawkaSort (zveno*);
    void PrintTree (zveno *, int);
    zveno** GetTree() { return &UkStr; };
    zveno* GetTree1() { return UkStr; };
};

int Tree::Poisk (char ENT, // .
                 zveno ** Res //  .
                )
{
  zveno* q;
  int vozvr=0;

  *Res = NULL;
  q = (*UkStr).Sled; //   !
  while  (q!=NULL && *Res==NULL)
  {
    if (q->Element == ENT)
      {  vozvr=1; *Res = q; return vozvr;}
    q = q->Sled;
  }
  return vozvr;
}

int Tree::Poisk1 (zveno** st, float kol, zveno** Res)
//   p    .
{
  zveno *q = (**st).Sled,*q1 = (*st);
  int vozvr=0;

  *Res = NULL;
  while  (q!=NULL && *Res == NULL)
  {
   if  (q->Kol<kol) { vozvr=1; *Res = q; }
   q = q->Sled; q1 = q1->Sled;
  }
  if  (*Res==NULL)  *Res = q1;
  return vozvr;
}

int Tree::Kolich (char *F, char S)
//  p  S   F.
//          -  p K.
{
  int K = 0;

  for (int i=0;i<strlen(F);i++)
	 if (F[i]==S)  K++;
  return K;
}


void Tree::Redaktor (int L)
//   Kol  p   p.
{
  zveno *q=(*UkStr).Sled;

  while  (q!=NULL)
  { q->Kol = q->Kol/L; q = q->Sled; }
}

void Tree::Dobavlenie (char bukva, // 
                       float kol,  //.
                       zveno **Sp  // .
                       )
//   , p   p.
{
  zveno *q, *Res=NULL, *kladovaq;

  q = new (zveno);
  q->Element = bukva;
  q->Kol = kol;
  q->Left = q->Right = NULL;
  q->Sled = q->Father = NULL;
  if ((**Sp).Sled==NULL) (**Sp).Sled = q;
  else
   if  (Poisk1 (&(*Sp),kol,&Res))
   {
     kladovaq = new (zveno); (*kladovaq) = (*Res);
     (*Res) = (*q);  Res->Sled = kladovaq;
   }
   else  Res->Sled = q;
}


void Tree::Ukazateli (zveno** zv, zveno** zv_p)
//   p  pp .
{
  *zv_p = UkStr->Sled; *zv = UkStr;
  while  (  (*zv_p)->Sled->Sled != NULL)
     { *zv = *zv_p; *zv_p = (*zv_p)->Sled; }
}

void Tree::Vyvod ()
//   p.
{
  zveno *q = UkStr->Sled;

  while  (q!=NULL)
  {
    cout << q->Element << " (" << q->Kol <<") --> "; 
    q = q->Sled;
  }
  cout << endl;
}

void Tree::WstawkaSort (zveno* zv)
{
  zveno *w1,*w2;

  w2 = UkStr; w1 = w2->Sled;
  while  (w1!=NULL && w1->Kol > zv->Kol)  
    {  w2 = w1; w1 = w2->Sled; }
  if  (w1==NULL || w1->Kol <= zv->Kol)
    { w2->Sled = zv; zv->Sled = w1; }
}

void Tree::PrintTree (zveno *w, int l)
{
  if  (w!=NULL)
  {
    PrintTree (w->Right,l+1);
    for (int i=1;i<=l;i++) cout << "   ";
    cout << w->Element << " (" << w->Kol << ")\n";
    PrintTree (w->Left,l+1);
  }
}

void main()
{
  Tree A;
  char T[255]; // p.
  int i,j;
  zveno* Res=NULL;
  zveno *Q[256];

  cout << " , p    ...\n";
  gets (T);

  //pp , p  .
  for (i=0;i<strlen(T);i++)
  {
    if (!A.Poisk (T[i],&Res) )
       A.Dobavlenie (T[i],A.Kolich(T,T[i]),A.GetTree());
  }
  // ------------------------------- //
  A.Redaktor (strlen(T));
  cout << " :\n";
  A.Vyvod ();
  //  Q    .
  zveno *UkZv = A.GetTree1()->Sled, *UkZv_p=NULL, *Sli;
  i = 0;
  while (UkZv!=NULL)
  {  Q[i] = UkZv; i++; UkZv = UkZv->Sled; }
  //p p .
  while  (A.GetTree1()->Sled->Sled!=NULL)
  {
    A.Ukazateli (&UkZv,&UkZv_p);
    //   p .
    Sli = new (zveno);
    Sli->Element = '*';
    Sli->Kol = UkZv_p->Kol + UkZv_p->Sled->Kol;
    Sli->Left = UkZv_p;
    Sli->Right = UkZv_p->Sled;
    Sli->Father = Sli->Sled = NULL;
    UkZv_p->Father = Sli;
    UkZv_p->Sled->Father = Sli;
    //     p .
    UkZv->Sled = NULL;
    UkZv_p->Sled = NULL;
    // ,   Sli  .
    if  (A.GetTree1()->Sled==NULL)  A.GetTree1()->Sled = Sli;
    else  A.WstawkaSort (Sli);
  }
  cout <<"p p...\n";
  A.PrintTree (A.GetTree1()->Sled,0);
  cout << "--------------------------------------------- " << endl;
  //p  .
  cout << "p  p  ...\n";
  char Cod_symbol[40];
  char Cod_Haffmen[255]; //  p T.
  char temp[255];
  strcpy(Cod_symbol,"");
  strcpy(Cod_Haffmen,"");
  for(i=0;i<strlen(T);i++)
  {
   //H   .
   j = 0;
   while (Q[j]->Element!=T[i]) j++;
   // p  ""...
   UkZv = Q[j];
   while (UkZv->Father!=NULL)
    if  (UkZv->Father->Left==UkZv)
     {
       strcpy(temp,"1");
       strcat(temp,Cod_symbol);
       strcpy(Cod_symbol,temp);
       UkZv = UkZv->Father;
     }
    else
     {
       strcpy(temp,"0");
       strcat(temp,Cod_symbol);
       strcpy(Cod_symbol,temp);
       UkZv = UkZv->Father;
     }
   strcat (Cod_Haffmen,Cod_symbol);
   strcpy (Cod_symbol,"");
  }
  cout << " p ... " << Cod_Haffmen << endl;
  cout << " : "<<
		100 * strlen (Cod_Haffmen) / 8.0 / strlen (T) << "%\n";
  //p p .
  cout << "  p... " << T << endl;
  strcpy (T,"");
  //   p p.
  UkZv = A.GetTree1()->Sled;
  i = 0;
  while  (i<strlen(Cod_Haffmen))
  {
    while  (UkZv->Left!=NULL && UkZv->Right!=NULL)
    {
      if  (Cod_Haffmen[i]=='1') UkZv = UkZv->Left;
      else  UkZv = UkZv->Right;
      i++;
    }
    char s[2];
    s[0]=UkZv->Element;s[1]='\0';
    strcat(T,s);
    UkZv = A.GetTree1()->Sled;
  }
  cout << "p..." << T << endl;
}